/// <reference types="node" />
import { EventEmitter } from 'events';
export declare type VimValue = number | boolean | string | number[] | {
    [key: string]: any;
} | null;
export declare class BaseApi extends EventEmitter {
    _session: any;
    _data: any;
    _decode: any;
    protected _isReady: any;
    protected prefix: string;
    logger: any;
    constructor({session, data, logger, metadata}: {
        session;
        logger?;
        data?;
        metadata?;
    });
    equals(other: any): boolean;
    request(name: any, args?: any[]): Promise<any>;
    _getArgsByPrefix(...args: any[]): any[];
    getVar(name: any): Promise<string>;
    setVar(name: any, value: any): Promise<any>;
    deleteVar(name: any): Promise<any>;
    getOption(name: any): Promise<any> | void;
    setOption(name: any, value: any): Promise<any> | void;
    notify(name: any, args: any): void;
}
