import { BaseApi } from './Base';
export interface BufferSetLines {
    start?: number;
    end?: number;
    strictIndexing?: boolean;
}
export interface BufferHighlight {
    hlGroup?: string;
    line?: number;
    colStart?: number;
    colEnd?: number;
    srcId?: number;
    async?: boolean;
}
export interface BufferClearHighlight {
    srcId?: number;
    lineStart?: number;
    lineEnd?: number;
    async?: boolean;
}
export interface AsyncBuffer extends Buffer, Promise<Buffer> {
}
export declare class Buffer extends BaseApi {
    readonly length: Promise<number>;
    readonly lines: Promise<Array<string>>;
    readonly changedtick: Promise<number>;
    getLines({start, end, strictIndexing}?: {
        start: number;
        end: number;
        strictIndexing: boolean;
    }): Promise<Array<string>>;
    setLines(_lines: string | string[], {start: _start, end: _end, strictIndexing}?: BufferSetLines): Promise<any>;
    insert(lines: Array<string> | string, start: number): Promise<any>;
    replace(_lines: Array<string> | string, start: number): Promise<any>;
    remove(start: number, end: number, strictIndexing: boolean): Promise<any>;
    append(lines: Array<string> | string): Promise<any>;
    name: string | Promise<string>;
    readonly valid: Promise<boolean>;
    mark(name: string): Promise<[number, number]>;
    addHighlight({hlGroup, line, colStart: _start, colEnd: _end, srcId: _srcId, async: _isAsync}: BufferHighlight): Promise<number>;
    clearHighlight({srcId, lineStart, lineEnd, async}?: BufferClearHighlight): Promise<any>;
}
