/// <reference types="node" />
export interface IModule {
    new (name: string): any;
    _resolveFilename: (file: string, context: any) => string;
    _extensions: {};
    _cache: {};
    _compile: () => void;
    wrap: (content: string) => string;
    require: (file: string) => NodeModule;
    _nodeModulePaths: (filename: string) => string[];
}
export interface IPluginObject {
    shouldCache: boolean;
    sandbox: ISandbox;
    specs: any[];
    handlers: {};
    import: any;
    module: any;
}
export interface ISandbox {
    process: NodeJS.Process;
    module: NodeModule;
    require: (p: string) => any;
    console: {
        log: Function;
    };
}
export declare function loadPlugin(filename: any, nvim: any, options?: {}): {
    shouldCache: boolean;
    sandbox: ISandbox;
    specs: any[];
    handlers: {};
    import: any;
    module: any;
};
